use super::{PossessionData, UseData, UseEffect};
use crate::models::item::{SkillType, ItemSpecialData};
use ansi::ansi;

use super::PossessionType::*;

pub fn data() -> PossessionData {
    PossessionData {
        display: "new corp licence",
        details: ansi!("A blank form that you can <bold>use<reset> to establish a new corp. It rests on a clipboard with a pencil attached by a chain. There is a space to <bold>write<reset> on it [try <bold>write Blah on licence<reset> followed by <bold>use licence<reset> to create a corp named Blah]"),
        aliases: vec!("form", "license", "licence", "new"),
        use_data: Some(UseData {
            uses_skill: SkillType::Persuade,
            diff_level: 4.0,
            crit_fail_effects: vec!(),
            fail_effects: vec!(),
            success_effects: vec!(
                UseEffect::BroadcastMessage {
                    messagef: Box::new(|player, _item, _target| (
                        format!(
                            "{} signs a contract establishing Blah as a corp\n",
                            &player.display_for_sentence(true, 1, true),
                        ),
                        format!("{} signs a contract establishing Blah as a corp\n",
                                &player.display_for_sentence(false, 1, true),
                        )))
                },
            ),
            errorf: Box::new(
                |item, _target|
                match item.special_data {
                    Some(ItemSpecialData::ItemWriting { .. }) => None,
                    _ => Some("You have to your corp's name on it first!".to_owned())
                }),
            ..Default::default()
        }),
        weight: 10,
        becomes_on_spent: Some(CertificateOfIncorporation),
        ..Default::default()
    }    
}

pub fn cert_data() -> PossessionData {
    PossessionData {
        display: "certificate of incorporation",
        details: "A certificate recording the formation of a corp.",
        weight: 10,
        ..Default::default()
    }    
}
